/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.entities.graphtype.rel

import com.alibaba.fastjson.annotation.JSONField
import com.persagy.server.datacenter.models.entities.base.BaseInfo
import com.persagy.service.models.annotations.SCascade
import io.swagger.v3.oas.annotations.media.Schema
import java.io.Serializable
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 业务空间
 *
 * @author  张维新
 */
@Schema(description = "空间实体类")
@Table(name = "zone_space_base")
open class RelZoneSpacefireClose: Serializable, BaseInfo() {

    /** 空间ID */
    @Schema(description = "空间ID")
    @Id
    @Column(name = "id")
    @JSONField(name = "Id")
    var id: String? = null

    /** 空间名称 */
    @Schema(description = "空间名称")
    @Column(name = "name")
    @JSONField(name = "Name")
    var name: String? = null

    /** 空间本地编码 */
    @Schema(description = "空间本地编码")
    @Column(name = "local_id")
    @JSONField(name = "LocalID")
    var localId: String? = null

    /** 空间本地名称 */
    @Schema(description = "空间本地名称")
    @Column(name = "local_name")
    @JSONField(name = "LocalName")
    var localName: String? = null

    /** 项目id */
    @Schema(description = "项目id")
    @Column(name = "project_id")
    @JSONField(name = "ProjectId")
    var projectId: String? = null

    /** 建筑id */
    @Schema(description = "建筑id")
    @Column(name = "building_id")
    @JSONField(name = "BuildingId")
    var buildingId: String? = null

    /** 楼层id */
    @Schema(description = "楼层id")
    @Column(name = "floor_id")
    @JSONField(name = "FloorId")
    var floorId: String? = null

    /** BIM模型中编码 */
    @Schema(description = "BIM模型中编码")
    @Column(name = "bim_id")
    @JSONField(name = "BIMID")
    var bimId: String? = null

//    /** 级联-建筑 */
//    @Schema(description = "级联-建筑")
//    @SCascade(table="zone_space_base", idColumn="id", childIdColumn="building_id")
//    @JSONField(name = "Building")
//    var building: Building? = null
//
//
//    /** 级联-楼层  */
//    @Schema(description = "级联-楼层")
//    @SCascade(table="zone_space_base", idColumn="id", childIdColumn="floor_id")
//    @JSONField(name = "Floor")
//    var floor: Floor? = null
//
//    /** 级联-空间类型  */
//    @Schema(description = "级联-空间类型")
//    @SCascade(table="zone_space_base", idColumn="id", childIdColumn="object_type")
//    @JSONField(name = "DClassDef")
//    var zoneName: DClassDef? = null
//
//    /** 级联-建筑 */
//    @Schema(description = "级联-建筑")
//    @SCascade(table="r_sp_in_bd", idColumn="space_id", childIdColumn="building_id")
//    @JSONField(name = "BuildingList")
//    var buildingList: ArrayList<Building>? = null
//
//    /** 级联-楼层  */
//    @Schema(description = "级联-楼层")
//    @SCascade(table="r_sp_in_fl", idColumn="space_id", childIdColumn="floor_id")
//    @JSONField(name = "FloorList")
//    var floorlList: ArrayList<Floor>? = null

    /** 级联-空间 */
    @Schema(description = "级联-空间")
    @SCascade(table="relationship.r_sp2sp", idColumn="id1", childIdColumn="id2",self = true,filter = "type = 'sp2sp_TrafficNetwork_3'" )
    @JSONField(name = "ObjectInfo")
    var objectInfo: ArrayList<RelZoneSpace>? = null

} // Class RelZoneSpacefireClose