/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

package com.persagy.server.datacenter.models.entities.task

import com.alibaba.fastjson.annotation.JSONField
import com.persagy.server.datacenter.models.entities.assistant.BIMLocation
import com.persagy.server.datacenter.models.entities.assistant.TaskPic
import com.persagy.server.datacenter.models.entities.base.RBaseInfo
import com.persagy.server.datacenter.models.entities.dict.EquipCategory
import com.persagy.server.datacenter.models.entities.objects.Building
import com.persagy.server.datacenter.models.entities.objects.Floor
import com.persagy.server.datacenter.models.entities.objects.Project
import com.persagy.service.models.annotations.SCascade
import io.swagger.v3.oas.annotations.media.Schema
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

/**
 * 模型任务
 *
 * @author  邓婷婷
 */
@Schema(description = "模型任务实体类")
@Table(name = "scantask.model_scan_task")
class ModelScanTaskQuery : RBaseInfo() {

    /** 任务id */
    @Schema(description = "任务id")
    @Id
    @Column(name = "id")
    @JSONField(name = "TaskId")
    var id: String? = null

    /** 设备或部件或资产id */
    @Schema(description = "设备或部件或资产id")
    @Id
    @Column(name = "equip_id")
    @JSONField(name = "EquipId")
    var equipId: String? = null

    /** 设备或部件或资产名称 */
    @Schema(description = "设备或部件或资产名称")
    @Column(name = "equip_name")
    @JSONField(name = "EquipName")
    var equipName: String? = null

    /** 设备本地编码 */
    @Schema(description = "设备本地编码")
    @Column(name = "local_id")
    @JSONField(name = "EquipLocalID")
    var localId: String? = null

    /** 设备本地名称 */
    @Schema(description = "设备本地名称")
    @Column(name = "local_name")
    @JSONField(name = "EquipLocalName")
    var localName: String? = null

    /** BIM模型中编码 */
    @Schema(description = "BIM模型中编码")
    @Column(name = "bim_id")
    @JSONField(name = "BIMID")
    var bimId: String? = null

    /** 项目id */
    @Schema(description = "项目id",required = true)
    @Column(name = "project_id")
    @JSONField(name = "ProjectId")
    var projectId: String? = null

    /** 设备类型code */
    @Schema(description = "设备类型code")
    @Column(name = "category")
    @JSONField(name = "Category")
    var category: String? = null

    /** 设备所在建筑id */
    @Schema(description = "设备所在建筑id")
    @Column(name = "building_id")
    @JSONField(name = "BuildingId")
    var buildingId: String? = null

    /** 设备所在楼层id */
    @Schema(description = "设备所在楼层id")
    @Column(name = "floor_id")
    @JSONField(name = "FloorId")
    var floorId: String? = null

    /** 任务状态 待验证1、已验证0、未找到-1  */
    @Schema(description = "任务状态-待验证1、已验证0、未找到-1")
    @Column(name = "task_state")
    @JSONField(name = "TaskState")
    var taskState: Int? = null

    /** 安装位置 */
    @Schema(description = "安装位置")
    @Column(name = "install_location")
    @JSONField(name = "InstallLocation")
    var installLocation: String? = null

    /** 设计图纸中编码 */
    @Schema(description = "设计图纸中编码")
    @Column(name = "cad_id")
    @JSONField(name = "CADID")
    var cadId: String? = null

    /** 方案id */
    @Schema(description = "方案id")
    @Column(name = "scheme_id")
    @JSONField(name = "SchemeId")
    var schemeId: String? = null

    /** 执行人 */
    @Schema(description = "执行人")
    @Column(name = "worker_id")
    @JSONField(name = "WorkerId")
    var workerId: String? = null

    /** 执行人名称 */
    @Schema(description = "执行人名称")
    @Column(name = "worker_name")
    @JSONField(name = "WorkerName")
    var workerName: String? = null

    /** 任务执行时间 */
    @Schema(description = "任务执行时间", example = "2017-10-15 08:30:00")
    @Column(name = "process_time")
    @JSONField(name = "ProcessTime")
    var processTime: String? = null

    /** 备注信息 */
    @Schema(description = "备注信息")
    @Column(name = "note")
    @JSONField(name = "Note")
    var note: String? = null

    /** 图片视频列表 */
    @Schema(description = "图片视频列表")
    @Column(name = "task_pic_list")
    @JSONField(name = "TaskPicList")
    var taskPicList: java.util.ArrayList<TaskPic>? = null

    /** 任务数据源  模型1 ，设备2，资产3 */
    @Schema(description = "任务数据源 模型1 ，设备2，资产3,部件4 ")
    @Column(name = "task_source")
    @JSONField(name = "TaskSource")
    var taskSource: Int? = null

    /** 任务类型 - 资产的撕贴换码状态 */
    @Schema(description = "任务类型 - 资产的撕贴换码状态 换码 2   撕码 3")
    @Column(name = "task_type")
    @JSONField(name = "TaskType")
    var taskType: String? = null

    /** 是否找到时间 */
    @Schema(description = "是否找到时间")
    @Column(name = "is_find_time")
    @JSONField(name = "IsFindTime")
    var isFindTime: String? = null

    /** 确认信息时间 */
    @Schema(description = "确认信息时间")
    @Column(name = "confirm_time")
    @JSONField(name = "ConfirmTime")
    var confirmTime: String? = null

    /** 打印二维码时间 */
    @Schema(description = "打印二维码时间")
    @Column(name = "qr_code_time")
    @JSONField(name = "QrCodeTime")
    var qrCodeTime: String? = null

    /** 补充铭牌照片时间 */
    @Schema(description = "补充铭牌照片时间")
    @Column(name = "nameplate_time")
    @JSONField(name = "NameplateTime")
    var nameplateTime: String? = null

    /** 正面照片时间 */
    @Schema(description = "正面照片时间")
    @Column(name = "positive_photo_time")
    @JSONField(name = "PositivePhotoTime")
    var positivePhotoTime: String? = null

    /** 侧面照片时间 */
    @Schema(description = "侧面照片时间")
    @Column(name = "side_photo_time")
    @JSONField(name = "SidePhotoTime")
    var sidePhotoTime: String? = null

    /** 局部照片时间 */
    @Schema(description = "局部照片时间")
    @Column(name = "region_photo_time")
    @JSONField(name = "RegionPhotoTime")
    var regionPhotoTime: String? = null

    /** 全景照片 */
    @Schema(description = "全景照片")
    @Column(name = "panoramic_photo_time")
    @JSONField(name = "PanoramicPhotoTime")
    var panoramicPhotoTime: String? = null

    /** 视频时间 */
    @Schema(description = "视频时间")
    @Column(name = "video_time")
    @JSONField(name = "VideoTime")
    var videoTime: String? = null

    /** 设备问题时间 */
    @Schema(description = "设备问题时间")
    @Column(name = "equip_problem_time")
    @JSONField(name = "EquipProblemTime")
    var equipProblemTime: String? = null

    /** 设备问题 */
    @Schema(description = "设备问题")
    @Column(name = "equip_problem")
    @JSONField(name = "EquipProblem")
    var equipProblem: String? = null

    /** 补充说明时间 */
    @Schema(description = "补充说明时间")
    @Column(name = "explain_time")
    @JSONField(name = "ExplainTime")
    var explainTime: String? = null

    /** 生产厂家 */
    @Schema(description = "生产厂家")
    @Column(name = "manufacturer")
    @JSONField(name = "Manufacturer")
    var manufacturer: String? = null

    /** 型号 */
    @Schema(description = "型号")
    @Column(name = "specification")
    @JSONField(name = "Specification")
    var specification: String? = null

    /** 供应商 */
    @Schema(description = "供应商")
    @Column(name = "supplier")
    @JSONField(name = "Supplier")
    var supplier: String? = null

    /** BIM模型中坐标 */
    @Schema(description = "BIM模型中坐标")
    @Column(name = "bim_location")
    @JSONField(name = "BIMLocation")
    var bimLocation: String? = null

    /** 任务确认人员名 */
    @Schema(description = "任务确认人员名")
    @Column(name = "confirming_person_name")
    @JSONField(name = "ConfirmingPersonName")
    var confirmingPersonName: String? = null

    /** 任务确认人id */
    @Schema(description = "任务确认人id")
    @Column(name = "confirming_person_id")
    @JSONField(name = "ConfirmingPersonId")
    var confirmingPersonId: String? = null



    /** BIM模型中坐标 */
    @Schema(description = "BIM模型中坐标json")
//    @Column(name = "location_json")
    @JSONField(name = "LocationJson")
    var locationJson: BIMLocation? = null
        get() {
            if (!bimLocation.isNullOrEmpty()){

                val split = bimLocation!!.split(",")
                var bimLocation = BIMLocation()
                if (split.size == 3){
                    bimLocation.x = split[0].toDouble()
                    bimLocation.y = split[1].toDouble()
                    bimLocation.z = split[2].toDouble()
                }else if (split.size == 2){

                    bimLocation.x = split[0].toDouble()
                    bimLocation.y = split[1].toDouble()
                    bimLocation.z = 0.0
                }
                return bimLocation
            }
            return null
        }

    /** 文件夹id */
    @Schema(description = "文件夹id")
    @Column(name = "folder_id")
    @JSONField(name = "FolderId")
    var folderId: String? = null

    /** 文件夹名 */
    @Schema(description = "文件夹名")
    @Column(name = "folder_name")
    @JSONField(name = "FolderName")
    var folderName: String? = null

    /** 文件id */
    @Schema(description = "文件id")
    @Column(name = "file_id")
    @JSONField(name = "FileId")
    var fileId: String? = null

    /** 文件名 */
    @Schema(description = "文件名")
    @Column(name = "file_name")
    @JSONField(name = "FileName")
    var fileName: String? = null

    /** 父类id */
    @Schema(description = "父类id")
    @Column(name = "parent_id")
    @Id
    @JSONField(name = "ParentId")
    var parentId: String? = null

    @Schema(description = "部件指向父类设备任务id")
    @Column(name = "task_parent_id")
    @JSONField(name = "TaskParentId")
    var taskParentId: String? = null

    /** 级联-项目   table  对应关系表   idColumn 对应 本类的id    childIdColumn 级联对象的关系id */
    @Schema(description = "级联-项目")
    @SCascade(table="scantask.model_scan_task", idColumn="id", childIdColumn="project_id")
    @JSONField(name = "Project")
    var project: Project? = null

    /** 级联-建筑 */
    @Schema(description = "级联-建筑")
    @SCascade(table="scantask.model_scan_task", idColumn="id", childIdColumn="building_id")
    @JSONField(name = "Building")
    var building: Building? = null

    /** 级联-楼层 */
    @Schema(description = "级联-楼层")
    @SCascade(table="scantask.model_scan_task", idColumn="id", childIdColumn="floor_id")
    @JSONField(name = "Floor")
    var floor: Floor? = null

    /** 级联-方案*/
    @Schema(description = "级联-方案")
    @SCascade(table="scantask.model_scan_task", idColumn="id", childIdColumn="scheme_id")
    @JSONField(name = "ScanScheme")
    var scanScheme: ScanScheme? = null

    /** 级联-部件*/
    @Schema(description = "级联-部件")
    @SCascade(table="scantask.model_scan_task", idColumn="parent_id", childIdColumn="equip_id")
    @JSONField(name = "Component")
    var component: ArrayList<ModelScanTaskQuery>? = null
//    @Schema(description = "级联-部件")
////    @SCascade(table="scantask.model_scan_task", idColumn="id", childIdColumn="equip_id")
////    @JSONField(name = "Equipment")
////    var equipment: Equipment? = null

    /** 级联-设备分类 */
    @Schema(description = "级联-设备分类")
    @SCascade(table="scantask.model_scan_task", idColumn="id", childIdColumn="category")
    @JSONField(name = "EquipCategory")
    var equipCategory: EquipCategory? = null

} // Class ModelScanTask